<?php

namespace EventPortal\Seeds;

use EventPortal\Domain\Admin\Models\Admin;
use EventPortal\Domain\Permission\Models\Role;
use EventPortal\Domain\User\Models\User;
use Illuminate\Database\Seeder;

class AdminSeeder extends Seeder
{
    public function run(): void
    {
        $this->createSuperAdmin();
        $this->createAdmin();
    }

    private function createSuperAdmin(): void
    {
        $role = Role::findByName('super-admin');

        if (User::where('email', 'super-admin@example.com')->first()) {
            return;
        }

        $user = User::create([
            'email' => 'super-admin@example.com',
            'first_name' => 'Super',
            'last_name' => 'Admin',
            'password' => bcrypt(config('auth.default_password')),
            'password_created_at' => now(),
        ]);

        $admin = Admin::create([
            'username' => 'SA1234',
            'department' => 'Digital',
            'job_title' => 'Being',
            'phone' => '01234 56789',
        ]);

        $user->admin()->save($admin);

        $admin->assignRole($role);
    }

    private function createAdmin(): void
    {
        $role = Role::findByName('admin');

        if (User::where('email', 'admin@example.com')->first()) {
            return;
        }
        
        $user = User::create([
            'email' => 'admin@example.com',
            'first_name' => 'Normal',
            'last_name' => 'Admin',
            'password' => bcrypt(config('auth.default_password')),
            'password_created_at' => now(),
        ]);

        $admin = Admin::create([
            'username' => 'S09876',
            'department' => 'Digital',
            'job_title' => 'Being',
            'phone' => '01234 23234',
        ]);

        $user->admin()->save($admin);

        $admin->assignRole($role);
    }
}
